//============================================================================
// Name        : postfix.cpp
// Author      : METHUZ DISCRETE KKU
// Version     :
// Copyright   : Your copyright notice
// Description : Using stack to change infix to post fix
// 				 then assume every atom to be true then compute
//				 Maybe exist some bug ,Plz let me know if anyone found
//============================================================================

#include <iostream>
#include <stdio.h>
#include <string.h>
using namespace std;
#define MAX 50
char infix[MAX];
char postfix[MAX];
char result[MAX];
int stack[MAX];
int top;


int push(int symbol){
	if(top>MAX){
		printf("STACK OVERFLOW\n");
		return -1;
	}else{
		top=top+1;
		stack[top] = symbol;
	}
	return 1;

}

int getweight(char symbol){
	switch(symbol){
	    case '(' : return 0;break;
		case '!' : return 3;break;
		case '&' : return 2;break;
		case '+' : return 1;break;
	}
}
int pop(){
	if(top==-1){
		cout<<"Stack underflow"<<endl;
		return -1;
	}
	else
		return (stack[top--]);
}
void clear(){
			top = 0;
			for(int i=0;i<MAX;i++){
				stack[i]=0;
				result[i]=0;
				infix[i]=0;
				postfix[i]=0;
			}
}
void compute(){
	int i,type,weight;
	int p=0;
	//char a,b;
	char next;

	stack[top]='#';
	int len=strlen(postfix);

	for(i=0;i<len;i++){
		int a,b;
		switch(postfix[i]){
			case '!' :a=pop();
					if(a=='T')
						a='F';
					else
						a='T';
					push(a);
					break;
			case '&' :a=pop();
					  b=pop();
					  if(a=='T'&& b=='T')
						  a='T';
					  else
						  a='F';
					  push(a);
					 break;
			case '+' :
					a=pop();
					b=pop();
					if(a=='T'||b=='T')
						a='T';
					else
						a='F';
					push(a);
					break;
			default : push(postfix[i]);

		}
	}
	while(stack[top]!='#')
				result[p++] = pop();
}
void infix2postfix(){
	int i,type,weight;
	int p=0;
	char next;

	stack[top]='#';
	int len=strlen(infix);

	for(i=0;i<len;i++){
		switch(infix[i]){
		case '(': push(infix[i]);break;
		case ')': while((next = pop()) != '(' )
					postfix[p++] = next;
				  break;
		case '!':
		case '&':
		case '+':
				weight = getweight(infix[i]);
				while(stack[top]!='#' && weight<= getweight(stack[top])){
					postfix[p++] = pop();
				}
				push(infix[i]);
				break;
		default:
				postfix[p++] = infix[i];
		}
	}
		while(stack[top]!='#')
			postfix[p++] = pop();
	}

int main() {

	char input[MAX];
	while(cin>>input){
		clear();
		strcpy(infix,input);
		infix2postfix();

		for(int i=0;i<strlen(postfix);i++){
			if(postfix[i]>='a')
				postfix[i]='T';
		}
		compute();
		//cout<<result;
		if(result[0]=='T')
			cout<<"YES";
		else
			cout<<"NO";
	}
	return 0;
}
